EBBTest = AceLibrary("AceAddon-2.0"):new()

local function copyTable(t)
	local x = {}
	for k,v in pairs(t) do
		x[k] = v
	end
	--table.setn(x, table.getn(t))
	setmetatable(x, getmetatable(t))
	return x
end

function EBBTest:OnEnable()
	local layout, data
	layout = {
		["icon"]				= "LEFT",											-- "LEFT", "RIGHT", false
		["iconcount"]			= true,												-- true, false
		["iconcountanchor"]		= "BOTTOMRIGHT",									-- <anchor>
		["iconcountfont"]		= "Fonts\\ARIALN.TTF",								-- <font>
		["iconcountfontsize"]	= 14,												-- <font size>
		["bar"]					= "Interface\\Addons\\ElkBuffBar\\BarTexture",		-- <texture path>, false
		["textTL"]				= "NAMERANKCOUNT",									-- false, "NAME", "NAMERANK", "NAMECOUNT", "NAMERANKCOUNT", "RANK", "COUNT", "TIMELEFT", "DEBUFFTYPE"
		["textTLfont"]			= "Fonts\\FRIZQT__.TTF",							-- <font>
		["textTLfontsize"]		= 14,												-- <font size>
		["textTLcolor"]			= {1, 1, 1},										-- <color set>
		["textTLalign"]			= "LEFT",											-- left, center, right
		["textTR"]				= "TIMELEFT",										-- false, "NAME", "NAMERANK", "NAMECOUNT", "NAMERANKCOUNT", "RANK", "COUNT", "TIMELEFT", "DEBUFFTYPE"
		["textTRfont"]			= "Fonts\\FRIZQT__.TTF",							-- <font>
		["textTRfontsize"]		= 14,												-- <font size>
		["textTRcolor"]			= {1, 1, 1},										-- <color set>
		["BUFFcolor"]			= {0.3, 0.5, 1},									-- <color set>
		["BUFFbgcolor"]			= {0, 0.5, 1},										-- <color set>
		["DEBUFFcolor"]			= {1, 0, 0},										-- <color set>
		["DEBUFFbgcolor"]		= {1, 0, 0},										-- <color set>
		["TENCHcolor"]			= {0.5, 0, 0.5},									-- <color set>
		["TENCHbgcolor"]		= {0.5, 0, 0.5},									-- <color set>
		["debufftypecolor"]		= true,												-- true, false
		["timeformat"]			= "CONDENSED",										-- "DEFAULT", "EXTENDED", "FULL", "SHORT", "CONDENSED"
		["width"]				= 350,
		["height"]				= 25
	}
	data = {
		["icon"]				= "Interface\\Icons\\INV_Scroll_03",
		["name"]				= "testing...",
		["rank"]				= 23,
		["count"]				= 1,
		["type"]				= "BUFF",
		["debufftype"]			= nil,
		["timemax"]				= 12345,
		["timeleft"]			= 4242,
		["id"]					= 1,
		["untilCancelled"]		= false
	}
	self.bar1 = EBB_Bar:new()
	self.bar1:UpdateLayout(layout)
	self.bar1:UpdateData(data)
	self.bar1:GetContainer():ClearAllPoints()
	self.bar1:GetContainer():SetPoint("TOPLEFT", UIParent, "BOTTOMLEFT", floor(GetScreenWidth() * .5), floor(GetScreenHeight() * .5))

	layout = copyTable(layout)
	layout.bar = "Interface\\AddOns\\Chronometer\\Textures\\banto.tga"
	layout.icon = "RIGHT"
	data = copyTable(data)
	data.name = "Rusty Nail"
	data.rank = 1769
	data.type = "TENCH"
	data.count = 23
	self.bar2 = EBB_Bar:new()
	self.bar2:UpdateLayout(layout)
	self.bar2:UpdateData(data)
	self.bar2:GetContainer():ClearAllPoints()
	self.bar2:GetContainer():SetPoint("TOPLEFT", self.bar1:GetContainer(), "BOTTOMLEFT")
	layout = copyTable(layout)
	layout.bar = "Interface\\AddOns\\Chronometer\\Textures\\Charcoal.tga"
	layout.height = 50
	layout.icon = "LEFT"
	layout.textTL = "NAMERANK"
	layout.textTLfont = "Fonts\\MORPHEUS.TTF"
	layout.textTLfontsize = 20
	layout.textTR = "COUNT"
	layout.textBL = "TIMELEFT"
	layout.textBLfont = "Fonts\\FRIZQT__.TTF"
	layout.textBLfontsize = 14
	layout.textBLcolor = {1, 1, 1}
	layout.textBR = "DEBUFFTYPE"
	layout.textBRfont = "Fonts\\FRIZQT__.TTF"
	layout.textBRfontsize = 14
	layout.textBRcolor = {1, 1, 1}
	data = copyTable(data)
	data.name = "Sunder Armor"
	data.rank = 4
	data.type = "DEBUFF"
	data.count = 7
	data.debufftype = "Poison"
	self.bar3 = EBB_Bar:new()
	self.bar3:UpdateLayout(layout)
	self.bar3:UpdateData(data)
	self.bar3:GetContainer():ClearAllPoints()
	self.bar3:GetContainer():SetPoint("TOPLEFT", self.bar2:GetContainer(), "BOTTOMLEFT")

	self.tbg = EBB_BarGroup:new()
	self.tbg.frames.container:Show()
	self.tbg.frames.container:SetPoint("TOPRIGHT", UIParent, "BOTTOMLEFT", floor(GetScreenWidth() * .5), floor(GetScreenHeight() * .5))
	self.tbg.layoutbars = EBBTest.bar3.layout
	self.tbg.layout = {growup = false, barspacing = 0, anchortext = "TEST", anchorcolor = {0, 0, 0.8}}
	self.tbg.data = {self.bar1.data, self.bar2.data, self.bar3.data}
	self.tbg:UpdateBars()
	self.tbg:ToggleAnchor(true)
end

ElkBuffBars = {}
ElkBuffBars.barcache = {}

function ElkBuffBars:GetBar()
	if #self.barcache > 0 then
		return table.remove(self.barcache, #self.barcache)
	else
		local bar = EBB_Bar:new()
		return bar
	end
end

function ElkBuffBars:RecycleBar(bar)
	bar:GetContainer():Hide()
	bar:GetContainer():SetParent(UIParent)
	table.insert(self.barcache, bar)
end

function ElkBuffBars:StickGroup(group)
end
